Index: MpdlXmlTextServer.py
===================================================================
--- MpdlXmlTextServer.py	(revision 400)
+++ MpdlXmlTextServer.py	(revision 401)
@@ -465,5 +465,5 @@
         
         data = self.getServerData("doc-query.xql","document=%s&queryType=%s&queryResultPageSize=%s&queryResultPN=%s&characterNormalization=%s&optionToggle=%s"%(docpath,queryType, pagesize, pn,characterNormalization,optionToggle))  
-        page = data.replace('page-fragment.xql?document=%s'%str(path),'%s?url=%s&viewMode=%s&tocMode=%s&tocPN=%s'%(selfurl,url, viewMode, tocMode, tocPN))
+        page = data.replace('page-fragment.xql?document=%s'%str(path),'%s?url=%s&viewMode=%s&tocMode=%s&tocPN=%s&optionToggle=%s'%(selfurl,url, viewMode, tocMode, tocPN,optionToggle))
         text = page.replace('mode=image','mode=texttool')
         logging.debug("documentViewer (characterNormalization) characterNormalization: %s"%(characterNormalization))
Index: zpt/page_main_gis.zpt
===================================================================
--- zpt/page_main_gis.zpt	(revision 381)
+++ zpt/page_main_gis.zpt	(revision 401)
@@ -1,4 +1,3 @@
-
-<tal:block tal:define="pageinfo python:options.get('pageinfo',None); docinfo python:options.get('docinfo',None) ;highlightQuery python:pageinfo.get('highlightQuery','');sn python:pageinfo.get('sn',''); characterNormalization python:pageinfo.get('characterNormalization','');">
-  <div tal:content="structure python:here.getTextPage(mode='gis',pn=pageinfo['current'],docinfo=docinfo,  pageinfo=pageinfo, characterNormalization=characterNormalization)"></div>
+<tal:block tal:define="pageinfo python:options.get('pageinfo',None); docinfo python:options.get('docinfo',None) ;highlightQuery python:pageinfo.get('highlightQuery','');sn python:pageinfo.get('sn',''); characterNormalization python:pageinfo.get('characterNormalization',''); optionToggle python:pageinfo.get('optionToggle','');">
+  <div tal:content="structure python:here.getTextPage(mode='gis',pn=pageinfo['current'],docinfo=docinfo,  pageinfo=pageinfo, characterNormalization=characterNormalization, optionToggle=optionToggle)"></div>
 </tal:block>
Index: zpt/page_main_text.zpt
===================================================================
--- zpt/page_main_text.zpt	(revision 383)
+++ zpt/page_main_text.zpt	(revision 401)
@@ -1,4 +1,3 @@
-
-<tal:block tal:define="pageinfo python:options.get('pageinfo',None); docinfo python:options.get('docinfo',None) ;highlightQuery python:pageinfo.get('highlightQuery','');sn python:pageinfo.get('sn','');characterNormalization python:pageinfo.get('characterNormalization','');">
-  <div tal:content="structure python:here.getTextPage(mode='text',pn=pageinfo['current'],docinfo=docinfo,  pageinfo=pageinfo, highlightQuery=highlightQuery,sn=sn, characterNormalization=characterNormalization)"></div>
+<tal:block tal:define="pageinfo python:options.get('pageinfo',None); docinfo python:options.get('docinfo',None) ;highlightQuery python:pageinfo.get('highlightQuery','');sn python:pageinfo.get('sn','');characterNormalization python:pageinfo.get('characterNormalization','');optionToggle python:pageinfo.get('optionToggle','');">
+  <div tal:content="structure python:here.getTextPage(mode='text',pn=pageinfo['current'],docinfo=docinfo,  pageinfo=pageinfo, highlightQuery=highlightQuery,sn=sn, characterNormalization=characterNormalization,optionToggle=optionToggle)"></div>
 </tal:block>
Index: zpt/page_main_text_dict.zpt
===================================================================
--- zpt/page_main_text_dict.zpt	(revision 380)
+++ zpt/page_main_text_dict.zpt	(revision 401)
@@ -1,3 +1,3 @@
-<tal:block tal:define="pageinfo python:options.get('pageinfo',None); docinfo python:options.get('docinfo',None) ;highlightQuery python:pageinfo.get('highlightQuery','');sn python:pageinfo.get('sn','');characterNormalization python:pageinfo.get('characterNormalization','');">
-  <div tal:content="structure python:here.getTextPage(mode='text_dict',pn=pageinfo['current'],docinfo=docinfo,  pageinfo=pageinfo, characterNormalization=characterNormalization)"></div>
+<tal:block tal:define="pageinfo python:options.get('pageinfo',None); docinfo python:options.get('docinfo',None) ;highlightQuery python:pageinfo.get('highlightQuery','');sn python:pageinfo.get('sn','');characterNormalization python:pageinfo.get('characterNormalization','');optionToggle python:pageinfo.get('optionToggle','');">
+  <div tal:content="structure python:here.getTextPage(mode='text_dict',pn=pageinfo['current'],docinfo=docinfo,  pageinfo=pageinfo, characterNormalization=characterNormalization,optionToggle=optionToggle)"></div>
 </tal:block>
Index: zpt/page_main_xml.zpt
===================================================================
--- zpt/page_main_xml.zpt	(revision 380)
+++ zpt/page_main_xml.zpt	(revision 401)
@@ -1,4 +1,3 @@
-
-<tal:block tal:define="pageinfo python:options.get('pageinfo',None); docinfo python:options.get('docinfo',None) ;highlightQuery python:pageinfo.get('highlightQuery','');sn python:pageinfo.get('sn','')  ">
-  <div tal:content="structure python:here.getTextPage(mode='xml',pn=pageinfo['current'],docinfo=docinfo, pageinfo=pageinfo)"></div>
+<tal:block tal:define="pageinfo python:options.get('pageinfo',None); docinfo python:options.get('docinfo',None) ;highlightQuery python:pageinfo.get('highlightQuery','');sn python:pageinfo.get('sn','');optionToggle python:pageinfo.get('optionToggle','');  ">
+  <div tal:content="structure python:here.getTextPage(mode='xml',pn=pageinfo['current'],docinfo=docinfo, pageinfo=pageinfo,optionToggle=optionToggle)"></div>
 </tal:block>